Encapsulation of SAN Header
Internet-Draft draft-encapsulation-of-san-header-00
Liwei Ma
ZTE Corporation
China
ma.liwei1@zte.com.cn
Detao Zhao
ZTE Corporation
No.50 Software Avenue
Nanjing
Jiangsu
210012
China
zhao.detao@zte.com.cn
Fenlin Zhou
ZTE Corporation
No.50 Software Avenue
Nanjing
Jiangsu
210012
China
zhou.fenlin@zte.com.cn
18 August 2022
INT
INTAREA
Encapsulation of SAN Header
This document proposes the encapsulation of the SAN header in the IPv6 data plane to carry the SAN related information, which could be used to associate the networking and computing resources indexed by SAN ID and route and forward the service traffic accordingly.
Introduction
SAN ID and SAN header is designed under the SAN framework[I-D.huang-service-aware-network-framework] as a interface between user and service as well as between service and network. Client requests the service through SAN header encapsulated in user data packet header by SAN routing and forwarding network. SAN network would index SAN ID based on the corresponding networking and computing policies and resources. This document provides several scalable solutions about SAN header encapsulation to support SAN architecture in IPv6 networks.
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Terminology
- SAN: Service Aware Network.
- SAN ID: Service Aware Network Identification, an identification designed to indicate the fundamental and common service types.
- SAN header: Encapsulation format of the SAN ID[I-D.service-identification-header-of-san].
The SAN Option
To support Service Awareness Network, it is necessary to define an IPv6 header option [RFC8200], that is the SAN Option.
The SAN option format is as the following format:
The SAN Option

    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                               | Opt Type=TBA1 |  Opt Data Len |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    |                           SAN header                          |
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Opt Type: 8-bit identifier of the type of option identifies this option as SAN Option. A new type value TBA1 for SAN option, recommended value 0x1D, the highest-order 3 bits should be set to zero-valued.
Opt Data Len: 8-bit unsigned integer. Length of the Option Data field of this option, that is, length of the SAN data.
SAN header: Option-Type-specific data. It carries the SAN identification. Data of this field specified in [I-D.service-identification-header-of-san].
Encapsulation Location and Structure
The SAN service identification can be encapsulated in several locations in the IPv6 packet extension header, such as Hop-by-Hop Options Header, Destination Options Header, and Segment Routing Header, depend upon the scenarios and implementation requirements.
Encapsulation in the Hop-by-Hop Options Header
SAN header can be carried as an option in the ipv6 hop-by-hop options header. The Option Type indicates that this option is a service identification SAN Option. The SAN header can be resolved by every SAN network nodes.
SAN header in Options header

    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |  Next Header  |  Hdr Ext Len  | Opt Type=TBA1 |  Opt Data Len |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    |                           SAN header                          |
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Encapsulation in the Destination Options Header
SAN header can be carried as an option in the ipv6 destination options header. The Option Type indicates that this option is a service identification SAN Option. The SAN header can be resolved by the SAN network nodes.
The encapsulation format is the same as Figure 2
Encapsulation in the Segment Routing Header
The segment routing header (SRH) and the SRH TLV is defined in [RFC8754]. The SAN header can be carried in SRH as one type of SRH TLV. When a SAN packet is sent to a SRv6 domain, according to the network service and computing service policy, the packet could be encapsulated or parsed SRv6 header, and the SAN header could be carried in the SRv6 header.
New SIDs defined in the future will indicate how the SAN type of SRH TLV works. The SAN header encapsulated in SRH TLV can be processed by the SAN nodes along the SRv6 path. The SAN TLV in SRH is as the following format:
SAN type of SRH TLV

     0                   1                   2                   3
     0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |   Type=TBA2   |     Length    |D|           RESERVED          |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
    |                                                               |
    |                           SAN header                          |
    |                                                               |
    +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type: A new type value TBA2 for SAN Type, suggested value 0x1D.
SAN header: Carries the SAN identification. Data of this field specified in [I-D.service-identification-header-of-san].
Other fields follow the definition in the [RFC8754].
IANA Considerations
IANA is requested to assign new values for the SAN Identification, one new IPv6 Header Option Type, one new SRH TLV Type, and one new Internet Protocol Numbers, as follows:
Value | Description | Reference
TBA1 | SAN option type | [this document]
TBA2 | SAN Type in SRH TLV | [this document]
Security Considerations
TBA
Acknowledgements
TBA
Normative References
[RFC8200]

Internet Protocol, Version 6 (IPv6) Specification
S. Deering
R. Hinden
July 2017
STD 86
RFC 8200
DOI 10.17487/RFC8200
[RFC8754]

IPv6 Segment Routing Header (SRH)
C. Filsfils, Ed.
D. Dukes, Ed.
S. Previdi
J. Leddy
S. Matsushima
D. Voyer
March 2020
RFC 8754
DOI 10.17487/RFC8754
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[I-D.huang-service-aware-network-framework]

Service Aware Network Framework
Daniel Huang
ZTE Corporation
Bin Tan
ZTE Corporation
24 May 2022
Internet-Draft draft-huang-service-aware-network-framework-00
[I-D.service-identification-header-of-san]

Service Identification Header of Service Aware Network
Liwei Ma
Fenlin Zhou
Hesong Li
18 August 2022
Internet-Draft draft-service-identification-header-of-san-00